/// <reference types="./foreign-key-constraint-builder.d.ts" />
import { ForeignKeyConstraintNode } from '../operation-node/foreign-key-constraint-node.js';
import { preventAwait } from '../util/prevent-await.js';
export class ForeignKeyConstraintBuilder {
    #node;
    constructor(node) {
        this.#node = node;
    }
    onDelete(onDelete) {
        return new ForeignKeyConstraintBuilder(ForeignKeyConstraintNode.cloneWith(this.#node, {
            onDelete,
        }));
    }
    onUpdate(onUpdate) {
        return new ForeignKeyConstraintBuilder(ForeignKeyConstraintNode.cloneWith(this.#node, {
            onUpdate,
        }));
    }
    toOperationNode() {
        return this.#node;
    }
}
preventAwait(ForeignKeyConstraintBuilder, "don't await ForeignKeyConstraintBuilder instances directly.");
